Elasticpools - Create
Create a new elastic pool. This will create a new TaskAgentPool at the organization level. If a project id is provided, this will create a new TaskAgentQueue in the specified project.
POST https://dev.azure.com/{organization}/_apis/distributedtask/elasticpools?poolName={poolName}&api-version=7.0
POST https://dev.azure.com/{organization}/_apis/distributedtask/elasticpools?poolName={poolName}&authorizeAllPipelines={authorizeAllPipelines}&autoProvisionProjectPools={autoProvisionProjectPools}&projectId={projectId}&api-version=7.0
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
organization
|
path | True |
string |
The name of the Azure DevOps organization. |
|
api-version
|
query | True |
string |
Version of the API to use. This should be set to '7.0' to use this version of the api. |
|
pool
|
query | True |
string |
Name to use for the new TaskAgentPool |
|
authorize
|
query |
boolean |
Setting to determine if all pipelines are authorized to use this TaskAgentPool by default. |
|
|
auto
|
query |
boolean |
Setting to automatically provision TaskAgentQueues in every project for the new pool. |
|
|
project
|
query |
string (uuid) |
Optional: If provided, a new TaskAgentQueue will be created in the specified project. |
Request Body
| Name | Type | Description |
|---|---|---|
| agentInteractiveUI |
boolean |
Set whether agents should be configured to run with interactive UI |
| azureId |
string |
Azure string representing to location of the resource |
| desiredIdle |
integer (int32) |
Number of agents to have ready waiting for jobs |
| desiredSize |
integer (int32) |
The desired size of the pool |
| maxCapacity |
integer (int32) |
Maximum number of nodes that will exist in the elastic pool |
| maxSavedNodeCount |
integer (int32) |
Keep nodes in the pool on failure for investigation |
| offlineSince |
string (date-time) |
Timestamp the pool was first detected to be offline |
| osType |
Operating system type of the nodes in the pool |
|
| poolId |
integer (int32) |
Id of the associated TaskAgentPool |
| recycleAfterEachUse |
boolean |
Discard node after each job completes |
| serviceEndpointId |
string (uuid) |
Id of the Service Endpoint used to connect to Azure |
| serviceEndpointScope |
string (uuid) |
Scope the Service Endpoint belongs to |
| sizingAttempts |
integer (int32) |
The number of sizing attempts executed while trying to achieve a desired size |
| state |
State of the pool |
|
| timeToLiveMinutes |
integer (int32) |
The minimum time in minutes to keep idle agents alive |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
successful operation |
Security
accessToken
Personal access token. Use any value for the user name and the token as the password.
Type:
basic
Definitions
| Name | Description |
|---|---|
|
Elastic |
Data and settings for an elastic pool |
|
Elastic |
Returned result from creating a new elastic pool |
|
Elastic |
State of the pool |
|
Identity |
|
|
Operating |
Operating system type of the nodes in the pool |
|
Properties |
The class represents a property bag as a collection of key-value pairs. Values of all primitive types (any type with a |
|
Reference |
The class to represent a collection of REST reference links. |
|
Task |
An organization-level grouping of agents. |
|
Task |
Additional pool settings and details |
|
Task |
|
|
Task |
Gets or sets the type of the pool |
|
Task |
An agent queue. |
ElasticPool
Data and settings for an elastic pool
| Name | Type | Description |
|---|---|---|
| agentInteractiveUI |
boolean |
Set whether agents should be configured to run with interactive UI |
| azureId |
string |
Azure string representing to location of the resource |
| desiredIdle |
integer (int32) |
Number of agents to have ready waiting for jobs |
| desiredSize |
integer (int32) |
The desired size of the pool |
| maxCapacity |
integer (int32) |
Maximum number of nodes that will exist in the elastic pool |
| maxSavedNodeCount |
integer (int32) |
Keep nodes in the pool on failure for investigation |
| offlineSince |
string (date-time) |
Timestamp the pool was first detected to be offline |
| osType |
Operating system type of the nodes in the pool |
|
| poolId |
integer (int32) |
Id of the associated TaskAgentPool |
| recycleAfterEachUse |
boolean |
Discard node after each job completes |
| serviceEndpointId |
string (uuid) |
Id of the Service Endpoint used to connect to Azure |
| serviceEndpointScope |
string (uuid) |
Scope the Service Endpoint belongs to |
| sizingAttempts |
integer (int32) |
The number of sizing attempts executed while trying to achieve a desired size |
| state |
State of the pool |
|
| timeToLiveMinutes |
integer (int32) |
The minimum time in minutes to keep idle agents alive |
ElasticPoolCreationResult
Returned result from creating a new elastic pool
| Name | Type | Description |
|---|---|---|
| agentPool |
Created agent pool |
|
| agentQueue |
Created agent queue |
|
| elasticPool |
Created elastic pool |
ElasticPoolState
State of the pool
| Value | Description |
|---|---|
| online |
Online and healthy |
| offline | |
| unhealthy | |
| new |
IdentityRef
| Name | Type | Description |
|---|---|---|
| _links |
This field contains zero or more interesting links about the graph subject. These links may be invoked to obtain additional relationships or more detailed information about this graph subject. |
|
| descriptor |
string |
The descriptor is the primary way to reference the graph subject while the system is running. This field will uniquely identify the same graph subject across both Accounts and Organizations. |
| directoryAlias |
string |
Deprecated - Can be retrieved by querying the Graph user referenced in the "self" entry of the IdentityRef "_links" dictionary |
| displayName |
string |
This is the non-unique display name of the graph subject. To change this field, you must alter its value in the source provider. |
| id |
string |
|
| imageUrl |
string |
Deprecated - Available in the "avatar" entry of the IdentityRef "_links" dictionary |
| inactive |
boolean |
Deprecated - Can be retrieved by querying the Graph membership state referenced in the "membershipState" entry of the GraphUser "_links" dictionary |
| isAadIdentity |
boolean |
Deprecated - Can be inferred from the subject type of the descriptor (Descriptor.IsAadUserType/Descriptor.IsAadGroupType) |
| isContainer |
boolean |
Deprecated - Can be inferred from the subject type of the descriptor (Descriptor.IsGroupType) |
| isDeletedInOrigin |
boolean |
|
| profileUrl |
string |
Deprecated - not in use in most preexisting implementations of ToIdentityRef |
| uniqueName |
string |
Deprecated - use Domain+PrincipalName instead |
| url |
string |
This url is the full route to the source resource of this graph subject. |
OperatingSystemType
Operating system type of the nodes in the pool
| Value | Description |
|---|---|
| windows | |
| linux |
PropertiesCollection
The class represents a property bag as a collection of key-value pairs. Values of all primitive types (any type with a TypeCode != TypeCode.Object) except for DBNull are accepted. Values of type Byte[], Int32, Double, DateType and String preserve their type, other primitives are retuned as a String. Byte[] expected as base64 encoded string.
| Name | Type | Description |
|---|---|---|
| count |
integer (int32) |
The count of properties in the collection. |
| item |
object |
|
| keys |
string[] |
The set of keys in the collection. |
| values |
string[] |
The set of values in the collection. |
ReferenceLinks
The class to represent a collection of REST reference links.
| Name | Type | Description |
|---|---|---|
| links |
object |
The readonly view of the links. Because Reference links are readonly, we only want to expose them as read only. |
TaskAgentPool
An organization-level grouping of agents.
| Name | Type | Description |
|---|---|---|
| agentCloudId |
integer (int32) |
The ID of the associated agent cloud. |
| autoProvision |
boolean |
Whether or not a queue should be automatically provisioned for each project collection. |
| autoSize |
boolean |
Whether or not the pool should autosize itself based on the Agent Cloud Provider settings. |
| autoUpdate |
boolean |
Whether or not agents in this pool are allowed to automatically update |
| createdBy |
Creator of the pool. The creator of the pool is automatically added into the administrators group for the pool on creation. |
|
| createdOn |
string (date-time) |
The date/time of the pool creation. |
| id |
integer (int32) |
|
| isHosted |
boolean |
Gets or sets a value indicating whether or not this pool is managed by the service. |
| isLegacy |
boolean |
Determines whether the pool is legacy. |
| name |
string |
|
| options |
Additional pool settings and details |
|
| owner |
Owner or administrator of the pool. |
|
| poolType |
Gets or sets the type of the pool |
|
| properties |
The class represents a property bag as a collection of key-value pairs. Values of all primitive types (any type with a |
|
| scope |
string (uuid) |
|
| size |
integer (int32) |
Gets the current size of the pool. |
| targetSize |
integer (int32) |
Target parallelism. |
TaskAgentPoolOptions
Additional pool settings and details
| Value | Description |
|---|---|
| none | |
| elasticPool |
TaskAgentPool backed by the Elastic pool service |
| singleUseAgents |
Set to true if agents are re-imaged after each TaskAgentJobRequest |
| preserveAgentOnJobFailure |
Set to true if agents are held for investigation after a TaskAgentJobRequest failure |
TaskAgentPoolReference
| Name | Type | Description |
|---|---|---|
| id |
integer (int32) |
|
| isHosted |
boolean |
Gets or sets a value indicating whether or not this pool is managed by the service. |
| isLegacy |
boolean |
Determines whether the pool is legacy. |
| name |
string |
|
| options |
Additional pool settings and details |
|
| poolType |
Gets or sets the type of the pool |
|
| scope |
string (uuid) |
|
| size |
integer (int32) |
Gets the current size of the pool. |
TaskAgentPoolType
Gets or sets the type of the pool
| Value | Description |
|---|---|
| automation |
A typical pool of task agents |
| deployment |
A deployment pool |
TaskAgentQueue
An agent queue.
| Name | Type | Description |
|---|---|---|
| id |
integer (int32) |
ID of the queue |
| name |
string |
Name of the queue |
| pool |
Pool reference for this queue |
|
| projectId |
string (uuid) |
Project ID |